3 # Copyright (c) 2005 Linus Torvalds
10 a pack everything in a single pack
11 A same as -a, and turn unreachable objects loose
12 d remove redundant packs, and run git-prune-packed
13 f pass --no-reuse-delta to git-pack-objects
14 F pass --no-reuse-object to git-pack-objects
15 n do not run git-update-server-info
17 l pass --local to git-pack-objects
19 window= size of the window used for delta compression
20 window-memory= same as the above, but limit memory size instead of entries count
21 depth= limits the maximum delta depth
22 max-pack-size= maximum size of each packfile
27 no_update_info= all_into_one= remove_redundant= unpack_unreachable=
28 local= no_reuse= extra=
32 -n) no_update_info=t ;;
35 unpack_unreachable=--unpack-unreachable ;;
36 -d) remove_redundant=t ;;
38 -f) no_reuse=--no-reuse-delta ;;
39 -F) no_reuse=--no-reuse-object ;;
41 --max-pack-size|--window|--window-memory|--depth)
42 extra="$extra $1=$2"; shift ;;
49 case "`git config --bool repack.usedeltabaseoffset || echo true`" in
51 extra="$extra --delta-base-offset" ;;
54 PACKDIR="$GIT_OBJECT_DIRECTORY/pack"
55 PACKTMP="$PACKDIR/.tmp-$$-pack"
57 trap 'rm -f "$PACKTMP"-*' 0 1 2 3 15
59 # There will be more repacking strategies to come...
60 case ",$all_into_one," in
62 args='--unpacked --incremental'
66 if [ -d "$PACKDIR" ]; then
67 for e in `cd "$PACKDIR" && find . -type f -name '*.pack' \
68 | sed -e 's/^\.\///' -e 's/\.pack$//'`
70 if [ -e "$PACKDIR/$e.keep" ]; then
73 existing="$existing $e"
76 if test -n "$existing" -a -n "$unpack_unreachable" -a \
77 -n "$remove_redundant"
79 args="$args $unpack_unreachable"
85 mkdir -p "$PACKDIR" || exit
87 args="$args $local ${GIT_QUIET:+-q} $no_reuse$extra"
88 names=$(git pack-objects --keep-true-parents --honor-pack-keep --non-empty --all --reflog $args </dev/null "$PACKTMP") ||
90 if [ -z "$names" ]; then
91 say Nothing new to pack.
94 # Ok we have prepared all new packfiles.
96 # First see if there are packs of the same name and if so
97 # if we can move them out of the way (this can happen if we
98 # repacked immediately after packing fully.
106 test -f "$PACKDIR/$file" || continue
107 rm -f "$PACKDIR/old-$file" &&
108 mv "$PACKDIR/$file" "$PACKDIR/old-$file" || {
112 rollback="$rollback $file"
114 test -z "$failed" || break
117 # If renaming failed for any of them, roll the ones we have
118 # already renamed back to their original names.
122 for file in $rollback
124 mv "$PACKDIR/old-$file" "$PACKDIR/$file" ||
125 rollback_failure="$rollback_failure $file"
127 if test -n "$rollback_failure"
129 echo >&2 "WARNING: Some packs in use have been renamed by"
130 echo >&2 "WARNING: prefixing old- to their name, in order to"
131 echo >&2 "WARNING: replace them with the new version of the"
132 echo >&2 "WARNING: file. But the operation failed, and"
133 echo >&2 "WARNING: attempt to rename them back to their"
134 echo >&2 "WARNING: original names also failed."
135 echo >&2 "WARNING: Please rename them in $PACKDIR manually:"
136 for file in $rollback_failure
138 echo >&2 "WARNING: old-$file -> $file"
144 # Now the ones with the same name are out of the way...
148 fullbases="$fullbases pack-$name"
149 chmod a-w "$PACKTMP-$name.pack"
150 chmod a-w "$PACKTMP-$name.idx"
151 mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
152 mv -f "$PACKTMP-$name.idx" "$PACKDIR/pack-$name.idx" ||
156 # Remove the "old-" files
159 rm -f "$PACKDIR/old-pack-$name.idx"
160 rm -f "$PACKDIR/old-pack-$name.pack"
163 # End of pack replacement.
165 if test "$remove_redundant" = t
167 # We know $existing are all redundant.
168 if [ -n "$existing" ]
173 case " $fullbases " in
175 *) rm -f "$e.pack" "$e.idx" "$e.keep" ;;
180 git prune-packed ${GIT_QUIET:+-q}
183 case "$no_update_info" in
185 *) git update-server-info ;;